LeetCode 1025. Divisor Game

题目链接:https://leetcode.com/problems/divisor-game/

题意:Alice和Bob玩一个游戏,Alice先开始。最初,黑板上有一个数字N。每一轮,选手首先需要选择一个数x(0<x<N且N%x==0),并将黑板上的数字N替换成N-x。如果哪个选手无法继续操作,则意味着输掉了游戏。如果Alice赢了返回true。

分析:

(1)先从最简单的case入手。N=1,Alice必败;N=2,Alice只能选择1,则Bob必败,Alice必胜;N=3,Alice只能选择1,则Bob必胜,Alice必败;N=4,Alice可以选择1,也可以选择2,Alice选择1,则Bob必败Alice必胜,Alice选择2,则Bob必胜Alice必败,因此,Alice一定会选择1,因此Alice胜。

(2)由此可推出结论,当Alice面对数字N时,她所需要选择的数字x必须使得Bob在处理N-x时必败,她才可能获胜。因此,如果Alice所有可以选择的x都使得Bob在处理N-x时必胜,那么Alice必败;只要Alice所有可以选择的x中有一种情况能使Bob在处理N-x时必败,那Alice都是必胜的。

class Solution {
public:
    bool divisorGame(int N) {
        int dp[1010];
        dp[1] = 0;
        for(int i = 2; i <= N; ++i){
            dp[i] = 0;
            for(int j = 1; j < i; ++j){
                if(i % j == 0){
                    if(dp[i - j] == 0){
                        dp[i] = 1;
                        break;
                    }
                }
            }
        }
        if(dp[N]) return true;
        return false;
    }
};

  

原文地址:https://www.cnblogs.com/tyty-Somnuspoppy/p/12084221.html

时间: 2024-10-11 19:32:23

LeetCode 1025. Divisor Game的相关文章

leetcode 1025. 除数博弈(Divisor Game)

目录 题目描述: 示例 1: 示例 2: 解法: 题目描述: 爱丽丝和鲍勃一起玩游戏,他们轮流行动.爱丽丝先手开局. 最初,黑板上有一个数字 N .在每个玩家的回合,玩家需要执行以下操作: 选出任一 x,满足 0 < x < N 且 N % x == 0 . 用 N - x 替换黑板上的数字 N . 如果玩家无法执行这些操作,就会输掉游戏. 只有在爱丽丝在游戏中取得胜利时才返回 true,否则返回 false.假设两个玩家都以最佳状态参与游戏. 示例 1: 输入:2 输出:true 解释:爱丽

[1] LeetCode 1025.除数博弈

做的LeetCode第一题....疯狂错误编译, 原来true or false 是给你return的, 函数已经写好了..... 完整题目 题目大意: A B 两人玩游戏 , 轮流进行, A 先手, A 胜利则输出 true, A失败输出 false 游戏内容: 给一个数字n, 你可以进行一次操作,  将 n 变为 n-x, n的要求: x必须满足 n % x == 0(n可以被x整除) 并且  0 < x < n 分析: 1:  false   A先手 没有数字被1整除还小于1的 所以A不

Leetcode之动态规划(DP)专题-1025. 除数博弈(Divisor Game)

爱丽丝和鲍勃一起玩游戏,他们轮流行动.爱丽丝先手开局. 最初,黑板上有一个数字 N .在每个玩家的回合,玩家需要执行以下操作: 选出任一 x,满足 0 < x < N 且 N % x == 0 . 用 N - x 替换黑板上的数字 N . 如果玩家无法执行这些操作,就会输掉游戏. 只有在爱丽丝在游戏中取得胜利时才返回 True,否则返回 false.假设两个玩家都以最佳状态参与游戏. 示例 1: 输入:2 输出:true 解释:爱丽丝选择 1,鲍勃无法进行操作. 示例 2: 输入:3 输出:f

LeetCode.1071-字符串最大公约数(Greatest Common Divisor of Strings)

这是小川的第391次更新,第421篇原创 01 看题和准备 今天介绍的是LeetCode算法题中Easy级别的第253题(顺位题号是1071).对于字符串S和T,当且仅当S = T + ... + T(T与自身连接1次或更多次)时,我们说"T除S". 返回最大的字符串X,使得X除以str1,X除以str2. 例如: 输入:str1 ="ABCABC",str2 ="ABC" 输出:"ABC" 输入:str1 ="AB

【leetcode】1283. Find the Smallest Divisor Given a Threshold

题目如下: Given an array of integers nums and an integer threshold, we will choose a positive integer divisor and divide all the array by it and sum the result of the division. Find the smallest divisor such that the result mentioned above is less than o

[LeetCode]题解(python):029-Divide Two Integers

题目来源: https://leetcode.com/problems/divide-two-integers/ 题意分析: 不用乘法,除法和mod运算来实现一个除法.如果数值超过了int类型那么返回int的最大值. 题目思路: 初步来说,有两个做法. ①模拟除法的过程,从高位开始除,不够先右挪一位.这种方法首先要将每一位的数字都先拿出来,由于最大int类型,所以输入的长度不超过12位.接下来就是模拟除法的过程. ②利用左移操作来实现出发过程.将一个数左移等于将一个数×2,取一个tmp = di

LeetCode --- 29. Divide Two Integers

题目链接:Divide Two Integers Divide two integers without using multiplication, division and mod operator. If it is overflow, return MAX_INT. 这道题的要求是在不使用乘法.除法.取模运算的前提下实现两个整数相除.如果溢出,返回MAX_INT. 这道题的直接思路是用被除数不断减去除数,直到为0.这种方法的迭代次数是结果的大小,即比如结果为n,算法复杂度是O(n). 可以

leetcode 锁掉的题目清单

也刷leetcode, 先把锁掉的题目留备份好了: 156 Binary Tree Upside Down  [1] Problem: Given a binary tree where all the right nodes are either leaf nodes with a sibling (a left node that shares the same parent node) or empty, flip it upside down and turn it into a tre

[Leetcode][Python]29: Divide Two Integers

# -*- coding: utf8 -*-'''__author__ = '[email protected]' 29: Divide Two Integershttps://oj.leetcode.com/problems/divide-two-integers/ Divide two integers without using multiplication, division and mod operator.If it is overflow, return MAX_INT. ===C